import Node from './node';
export default class Edge {
    private _name;
    private _source;
    private _target;
    /**
     * Creates a new edge.
     * @param source The node the edge originates from.
     * @param target The node the edge ends at.
     */
    constructor(source: Node, target: Node);
    /**
     * Returns the name of the edge.
     */
    get name(): string;
    /**
     * Returns the source node of the edge.
     */
    get source(): Node;
    /**
     * Returns the target node of the edge.
     */
    get target(): Node;
}
