"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Edge {
    /**
     * Creates a new edge.
     * @param source The node the edge originates from.
     * @param target The node the edge ends at.
     */
    constructor(source, target) {
        this._name = `${source.id} -> ${target.id}`;
        this._source = source;
        this._target = target;
        this.source.outgoingEdges.push(this);
        this.target.incomingEdges.push(this);
    }
    /**
     * Returns the name of the edge.
     */
    get name() {
        return this._name;
    }
    /**
     * Returns the source node of the edge.
     */
    get source() {
        return this._source;
    }
    /**
     * Returns the target node of the edge.
     */
    get target() {
        return this._target;
    }
}
exports.default = Edge;
