import Edge from './edge';
export default class Node {
    private _id;
    private _incomingEdges;
    private _outgoingEdges;
    /**
     * Creates a new node.
     * @param name The name of the node.
     */
    constructor(id: string);
    /**
     * Returns the name of the node.
     */
    get id(): string;
    /**
     * Returns the incoming edges of the node.
     */
    get incomingEdges(): Edge[];
    /**
     * Returns the outgoing edges of the node.
     */
    get outgoingEdges(): Edge[];
    /**
     * Returns the number of edges ending on this node.
     */
    get inDegree(): number;
    /**
     * Returns the number of edges originating from this node.
     */
    get outDegree(): number;
}
