"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Node {
    /**
     * Creates a new node.
     * @param name The name of the node.
     */
    constructor(id) {
        this._id = id;
        this._incomingEdges = [];
        this._outgoingEdges = [];
    }
    /**
     * Returns the name of the node.
     */
    get id() {
        return this._id;
    }
    /**
     * Returns the incoming edges of the node.
     */
    get incomingEdges() {
        return this._incomingEdges;
    }
    /**
     * Returns the outgoing edges of the node.
     */
    get outgoingEdges() {
        return this._outgoingEdges;
    }
    /**
     * Returns the number of edges ending on this node.
     */
    get inDegree() {
        return this.incomingEdges.length;
    }
    /**
     * Returns the number of edges originating from this node.
     */
    get outDegree() {
        return this.outgoingEdges.length;
    }
}
exports.default = Node;
