import * as Shift from 'shift-ast';
export default class TraversalHelper {
    /**
     * Replaces a node within a given section of the AST.
     * @param root The root node.
     * @param node The node to replace.
     * @param replacement The replacement node, nodes or null.
     */
    static replaceNode(root: Shift.Node, node: Shift.Node, replacement: Shift.Node | Shift.Node[] | null): void;
    /**
     * Removes a node within the given section of the AST.
     * @param root The root node.
     * @param node The node to remove.
     */
    static removeNode(root: Shift.Node, node: Shift.Node): void;
}
