"use strict";
/**
 * Taken from https://github.com/jsoverson/shift-traverse-js/blob/master/src/index.js
 * All credit goes to jsoverson
 */
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.replace = exports.traverse = void 0;
const estraverse_1 = __importDefault(require("estraverse"));
const shiftSpec_1 = __importDefault(require("./shiftSpec"));
const environment = estraverse_1.default.cloneEnvironment();
Object.keys(environment.Syntax)
    .filter(key => key !== 'Property')
    .forEach(key => {
    delete environment.Syntax[key];
    delete environment.VisitorKeys[key];
});
Object.assign(environment.Syntax, Object.keys(shiftSpec_1.default).reduce((result, key) => {
    result[key] = key;
    return result;
}, {}));
Object.assign(environment.VisitorKeys, Object.keys(shiftSpec_1.default).reduce((result, key) => {
    result[key] = shiftSpec_1.default[key].fields.map((field) => field.name);
    return result;
}, {}));
const traverse = environment.traverse;
exports.traverse = traverse;
const replace = environment.replace;
exports.replace = replace;
