import Modification from '../../modification';
import * as Shift from 'shift-ast';
export default class PropertySimplifier extends Modification {
    /**
     * Creates a new modification.
     * @param ast The AST.
     */
    constructor(ast: Shift.Script);
    /**
     * Executes the modification.
     */
    execute(): void;
    /**
     * Simplifies all computed members to static members within a given node.
     * @param node The AST node.
     */
    private simplifyComputedMembers;
    /**
     * Returns whether a node is a computed member expression with a string property
     * and should be converted to a static member expression.
     * @param node The AST node.
     */
    private isStringComputedMember;
}
