export default class NameMapping {
    private readonly mappings;
    private readonly children;
    /**
     * Creates a new name mapping.
     */
    constructor();
    /**
     * Adds a new mapping.
     * @param name The original variable name.
     * @param newName The new variable name.
     */
    addMapping(name: string, newName: string): void;
    /**
     * Adds a child name mapping.
     * @param child The child name mapping.
     */
    addChild(child: NameMapping): void;
    /**
     * Serializes the mapping to an object (suitable for JSON.stringify).
     * @returns The mapping object.
     */
    serialize(): any;
}
